datablock ItemData(StaticThrustersItem)
{
	category = "Item";

	equipment = true;

	shapeFile = "./3Dbolt.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Static Thrusters";
	iconName = "./Icon_StaticThrusters";
	doColorShift = false;
	colorShiftColor = "0.200 0.200 0.200 1.000";
	
	image = StaticThrustersImage;
	canDrop = true;
};

datablock ShapeBaseImageData(StaticThrustersImage)
{
   shapeFile = "./blank.dts";
   emap = true;

   mountPoint = 0;
   offset = "0.13 0.2 -0.8";
   rotation = eulerToMatrix("0 0 0");
   eyeOffset = "0.13 0.2 -0.8";
   eyeRotation = eulerToMatrix("0 0 0");

   doColorShift = true;
	colorShiftColor = StaticThrustersItem.colorShiftColor;
   
  
   correctMuzzleVector = false;

   className = "ToolImage";

   item = StaticThrustersItem;

   melee = true;
   armReady = false;

   doColorShift = true;
   colorShiftColor = StaticThrustersItem.colorShiftColor;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";


	stateName[1]                     = "Ready";
	stateScript[1]                  = "onUse";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;


	stateName[2]                    = "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateScript[2]                  = "onFire";
};

datablock ShapeBaseImageData(StaticThrusters1Image)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 2;
   offset = "0.65 1 -1.1";
   rotation = eulerToMatrix("0 0 0");
   eyeOffset = "0.65 1 5.1";
   eyeRotation = eulerToMatrix("0 0 0");

   doColorShift = true;
	colorShiftColor = StaticThrusters2Item.colorShiftColor;
   
  
   correctMuzzleVector = false;

   className = "ToolImage";

   item = StaticThrusters2Item;

   melee = false;
   armReady = false;

   doColorShift = true;
   colorShiftColor = StaticThrustersItem2.colorShiftColor;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
};

datablock ShapeBaseImageData(StaticThrusters2Image)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = ("0 0 0");

   correctMuzzleVector = true;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   MPused = 0;
   projectile = LightningBolt;
   projectileType = Projectile;

   melee = false;
   armReady = false;
   
   lightType = "ConstantLight";
   lightColor = "0 1 1 1";
   LightTime = "1000";
   lightRadius = "4";

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.15;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSound[0]				= LightningBoltZapSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateEmitter[1]					= LightningBoltAmbientEmitter;
	stateEmitterTime[1]				= 600;

	stateName[2]					= "Fire";
	stateTransitionOnTimeout[2]		= "Reload";
	stateTimeoutValue[2]			= 1;
	stateFire[2]					= true;
	stateAllowImageChange[2]		= false;
	stateScript[2]					= "onFire";
	stateWaitForTimeout[2]			= true;

	stateName[3]					= "Reload";
	stateSequence[3]				= "Reload";
	stateTransitionOnTriggerUp[3]	= "Ready";
	stateTransitionOnTriggerDown[3]	= "Fire";
	stateSequence[3]				= "Ready";
};

datablock ShapeBaseImageData(LeftHandedStaticThrusters2Image)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = ("0 0 0");

   correctMuzzleVector = true;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   MPused = 0;
   projectile = LightningBolt;
   projectileType = Projectile;

   melee = false;
   armReady = false;
   
   lightType = "ConstantLight";
   lightColor = "0 1 1 1";
   LightTime = "1000";
   lightRadius = "4";

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.15;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSound[0]				= LightningBoltZapSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateEmitter[1]					= LightningBoltAmbientEmitter;
	stateEmitterTime[1]				= 600;

	stateName[2]					= "Fire";
	stateTransitionOnTimeout[2]		= "Reload";
	stateTimeoutValue[2]			= 1;
	stateFire[2]					= true;
	stateAllowImageChange[2]		= false;
	stateScript[2]					= "onFire";
	stateWaitForTimeout[2]			= true;

	stateName[3]					= "Reload";
	stateSequence[3]				= "Reload";
	stateTransitionOnTriggerUp[3]	= "Ready";
	stateTransitionOnTriggerDown[3]	= "Fire";
	stateSequence[3]				= "Ready";
};

function StaticThrusters2Image::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.mountImage(LeftHandedStaticThrusters2Image, 1);
}
function StaticThrusters2Image::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   %obj.unMountImage(1);
}

function StaticThrustersImage::onFire(%this, %obj, %slot)
{
	%client = %obj.client;
	if(%client.player.StaticThrustersing == 0)
	{
		%client.player.setDataBlock("PlayerStaticThrusters"); 
		%client.player.unmountimage(2);
		%client.player.mountimage(StaticThrusters2image, 2);
		%client.player.StaticThrustersing = 1;
	}else{
		%client.player.StaticThrustersing = 0;
		if(!isObject(%client.minigame))
		{
			%client.player.setDataBlock("PlayerInFamousArmor");
		}else{
			%client.player.setdatablock(%client.minigame.playerDatablock);
		}
		%client.player.unmountimage(2);
		%client.player.mountImage(StaticThrusters1Image, 2);
	}
}

datablock PlayerData(PlayerStaticThrusters : PlayerInFamousArmor)
{
	canJet = 0;
	ag_isAgile = 0;
	drag = 2;
	airControl = 0.5;
	uiname = "Static Thrusters Player";
};