datablock AudioProfile(LightningBoltZapSound)
{
   filename    = "./LightningBoltZapSound.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(LightningBoltLoopSound)
{
   filename    = "./LightningBoltLoopSound.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock ParticleData(LightningBoltAmbientParticle)
{
	dragCoefficient			= 3;
	gravityCoefficient		= 0;
	inheritedVelFactor		= 0.75;
	constantAcceleration	= 0;
	lifetimeMS			= 250;
	lifetimeVarianceMS	= 50;
	textureName			= "Add-Ons/Projectile_Radio_Wave/bolt";
	spinSpeed			= 10;
	spinRandomMin		= -300;
	spinRandomMax		= 290;
	colors[0]	= "0 1 1 1";
	colors[1]	= "0 1 1 0";
	sizes[0]	= 0.25;
	sizes[1]	= 1.1;
};
datablock ParticleEmitterData(LightningBoltAmbientEmitter)
{
   ejectionPeriodMS	= 30;
   periodVarianceMS	= 0;
   ejectionVelocity	= 1.0;
   velocityVariance	= 1.0;
   ejectionOffset	= 0.0;
   thetaMin			= 0;
   thetaMax			= 90;
   phiReferenceVel	= 0;
   phiVariance		= 360;
   overrideAdvance	= false;
   particles		= "LightningBoltAmbientParticle";

   uiName = "Lightning Bolt Ambient";
};

datablock ParticleData(LightningBoltTrailParticle)
{
	dragCoefficient			= 5;
	gravityCoefficient		= 0;
	inheritedVelFactor		= 0.15;
	constantAcceleration	= 0;
	lifetimeMS			= 1000;
	lifetimeVarianceMS	= 500;
	textureName			= "Add-Ons/Projectile_Radio_Wave/bolt";
	spinSpeed			= 10;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	= "0 1 1 1";
	colors[1]	= "0 0.5 1 0";
	sizes[0]	= 1;
	sizes[1]	= 0;
};
datablock ParticleEmitterData(LightningBoltTrailEmitter)
{
   ejectionPeriodMS	= 5;
   periodVarianceMS	= 0;
   ejectionVelocity	= 2;
   velocityVariance	= 1.5;
   ejectionOffset	= 0.2;
   thetaMin			= 115;
   thetaMax			= 175;
   phiReferenceVel	= 0;
   phiVariance		= 360;
   overrideAdvance	= false;
   particles		= "LightningBoltTrailParticle";

   uiName = "Lightning Bolt Trail";
};

datablock ExplosionData(LightningBoltExplosion)
{
   soundProfile = LightningBoltZapSound;

   lifeTimeMS = 250;

   particleEmitter = LightningBoltTrailEmitter;
   particleDensity = 150;
   particleRadius = 2.5;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "30 30 30";
   camShakeAmp = "7 2 7";
   camShakeDuration = 0.6;
   camShakeRadius = 2.5;

   lightStartRadius = 10;
   lightEndRadius = 0;
   lightStartColor = "0 1 1";
   lightEndColor = "0 0 1";

   damageRadius = 2.5;
   radiusDamage = 1;

   uiName = "Lightning Bolt Zap";
};

AddDamageType("LightningBoltD", '<bitmap:Add-Ons/Package_inFamous/CI_Lightning> %1', '%2 <bitmap:Add-Ons/Package_inFamous/CI_Lightning> %1', 1, 1);
AddDamageType("LightningBoltR", '<bitmap:Add-Ons/Package_inFamous/CI_Lightning> %1', '%2 <bitmap:Add-Ons/Package_inFamous/CI_Lightning> %1', 1, 0);

datablock ProjectileData(LightningBolt)
{
   sound = "LightningBoltLoopSound";
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 4.25;
   directDamageType    = $DamageType::LightningBoltD;
   radiusDamageType    = $DamageType::LightningBoltR;

   brickExplosionRadius		= 4;
   brickExplosionImpact		= true;
   brickExplosionForce		= 1;
   brickExplosionMaxVolume	= 20;
   brickExplosionMaxVolumeFloating	= 35;

   impactImpulse	= 400;
   verticalImpulse	= 400;
   explosion		= LightningBoltExplosion;
   particleEmitter	= LightningBoltTrailEmitter;

   muzzleVelocity	= 135;
   velInheritFactor	= 0;

   armingDelay		= 0;
   lifetime			= 4000;
   fadeDelay		= 4000;
   bounceElasticity	= 0.999;
   bounceFriction	= 0.001;
   isBallistic		= false;

   hasLight    = true;
   lightRadius = 5;
   lightColor  = "0 1 1";

   uiName = "Lightning Bolt";
};

datablock ItemData(LightningBoltItem)
{
	category	= "Weapon";
	className	= "Weapon";

	shapeFile	= "./3Dbolt.dts";
	rotate		= false;
	mass		= 0.2;
	density		= 0.1;
	elasticity	= 0.8;
	friction	= 0.2;
	emap		= true;

	uiName = "Lightning Bolt";
	iconName = "./Icon_LightningBolt";
	doColorShift = false;

	image = LightningBoltImage;
	canDrop = true;
};

datablock ShapeBaseImageData(LightningBoltImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = ("0 0 0");

   correctMuzzleVector = true;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   MPused = 2;
   projectile = LightningBolt;
   projectileType = Projectile;

   melee = false;
   armReady = true; //Raise your arm?
   
   lightType = "ConstantLight";
   lightColor = "0 1 1 1";
   LightTime = "1000";
   lightRadius = "4";

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.15;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSound[0]				= LightningBoltZapSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateEmitter[1]					= LightningBoltAmbientEmitter;
	stateEmitterTime[1]				= 600;

	stateName[2]					= "Fire";
	stateTransitionOnTimeout[2]		= "Reload";
	stateTimeoutValue[2]			= 0.5;
	stateFire[2]					= true;
	stateAllowImageChange[2]		= false;
	stateScript[2]					= "onFire";
	stateWaitForTimeout[2]			= true;

	stateName[3]					= "Reload";
	stateSequence[3]				= "Reload";
	stateTransitionOnTriggerUp[3]	= "Ready";
	stateTransitionOnTriggerDown[3]	= "Fire";
	stateSequence[3]				= "Ready";
};

function LightningBoltImage::onFire(%this, %obj, %slot)
{
	if(%obj.lst[%this] > getSimTime())
	{
		return;
	}
	%obj.lst[%this] = getSimTime() + 500;
	if(%obj.getDatablock().isMage)
	{
		if(%obj.hasEnergy(%this.MPused))
		{
			parent::onFire(%this, %obj, %slot);
			%obj.setEnergyLevel(%obj.getEnergyLevel() - %this.MPused);
		}
		else if(isObject(%client = %obj.getControllingClient()))
		{
			%client.centerPrint("\c4Not enough Electricity!", 3);
		}
	}
	else
	{
		parent::onFire(%this, %obj, %slot);
	}
}

package LightningBolt
{
	function armor::damage(%this, %obj, %sourceObject, %pos, %amt, %type)
	{
		if(%type == $DamageType::LightningBoltR || %type == $DamageType::LightningBoltD)
		{
			if(%obj.getWaterCoverage() > 0)
			{
				%amt*= 1.5;
			}
			if(%obj.getWaterCoverage() == 1)
			{
				%amt*= 1.5;
			}
		}
		parent::damage(%this, %obj, %sourceObject, %pos, %amt, %type);
	}
};
activatePackage(LightningBolt);