datablock ParticleData(iShockWaveSmokeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 250;
	textureName          = "Add-Ons/Projectile_Radio_Wave/bolt";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

	colors[0]	= "0 1 1 1";
	colors[1]	= "0 1 1 0";

	sizes[0]      = 0.25;
   	sizes[1]      = 1.0;

   times[0] = 0.0;
   times[1] = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(iShockWaveSmokeEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 10.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 25;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "iShockWaveSmokeParticle";

   uiName = "iShockWave  Smoke";
};


datablock ParticleData(iShockWaveTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 105;
	lifetimeVarianceMS   = 100;
	textureName          = "Add-Ons/Projectile_Radio_Wave/bolt";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]	= "0 1 1 1";
	colors[1]	= "0 0.5 1 0";

	sizes[0]      = 0;
	sizes[1]      = 3;
  	sizes[2]      = 9;
 	sizes[3]      = 12;

  	times[0] = 0;
  	times[1] = 0.3;
  	times[2] = 0.7;
  	times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(iShockWaveTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "iShockWaveTrailParticle";

   uiName = "iShockWave Trail";
};


datablock ExplosionData(iShockwaveExplosion)
{
   explosionShape = "Add-Ons/Weapon_Rocket Launcher/explosionSphere1.dts";
	soundProfile = LightningBoltZapSound;

   lifeTimeMS = 50;

   particleEmitter = iShockWaveSmokeEmitter;
   particleDensity = 10;
   particleRadius = 7;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 3;
   radiusDamage = 1;

   impulseRadius = 4;
   impulseForce = 3300;
};


AddDamageType("iShockWaveD", '<bitmap:Add-Ons/Package_inFamous/CI_Lightning> %1', '%2 <bitmap:Add-Ons/Package_inFamous/CI_Lightning> %1', 1, 1);
AddDamageType("iShockWaveR", '<bitmap:Add-Ons/Package_inFamous/CI_Lightning> %1', '%2 <bitmap:Add-Ons/Package_inFamous/CI_Lightning> %1', 1, 0);


datablock ProjectileData(iShockWaveProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 49.5;
   directDamageType    = $DamageType::iShockWaveD;
   radiusDamageType    = $DamageType::iShockWaveR;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;
   
   sound = LightningBoltLoopSound;
   particleEmitter     = iShockWaveTrailEmitter;
   explosion           = iShockwaveExplosion;
   
   impactImpulse	     = 500;
   verticalImpulse	   = 500;

   brickExplosionRadius = 3;
   brickExplosionImpact = true;
   brickExplosionForce  = 30;             
   brickExplosionMaxVolume = 30;
   brickExplosionMaxVolumeFloating = 60;

   armingDelay         = 0;
   lifetime            = 210;
   fadeDelay           = 0;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 5;
   lightColor  = "0 1 1";

   uiName = "iShockWave";
};

datablock ItemData(iShockWaveItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./3Dbolt.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "iShockwave";
	iconName = "./icon_iShockWave";
	doColorShift = false;
	colorShiftColor = "0.100 0.500 0.250 1.000";

	image = iShockWaveImage;
	canDrop = true;
};

datablock ShapeBaseImageData(iShockWaveImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = ("0 0 0");

   correctMuzzleVector = true;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   MPused = 75;
   projectile = iShockWaveProjectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;
   
   lightType = "ConstantLight";
   lightColor = "0 1 1 1";
   LightTime = "1000";
   lightRadius = "4";

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.15;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSound[0]				= LightningBoltZapSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateEmitter[1]					= iShockWaveSmokeEmitter;
	stateEmitterTime[1]				= 600;

	stateName[2]					= "Fire";
	stateTransitionOnTimeout[2]		= "Reload";
	stateTimeoutValue[2]			= 0.7;
	stateFire[2]					= true;
	stateAllowImageChange[2]		= false;
	stateScript[2]					= "onFire";
	stateWaitForTimeout[2]			= true;

	stateName[3]					= "Reload";
	stateSequence[3]				= "Reload";
	stateTransitionOnTriggerUp[3]	= "Ready";
	stateTransitionOnTriggerDown[3]	= "Fire";
	stateSequence[3]				= "Ready";
};

datablock ShapeBaseImageData(LeftHandediShockWaveImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = ("0 0 0");

   correctMuzzleVector = true;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   MPused = 75;
   projectile = iShockWaveProjectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;
   
   lightType = "ConstantLight";
   lightColor = "0 1 1 1";
   LightTime = "1000";
   lightRadius = "4";

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.15;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSound[0]				= LightningBoltZapSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateEmitter[1]					= iShockWaveSmokeEmitter;
	stateEmitterTime[1]				= 600;

	stateName[2]					= "Fire";
	stateTransitionOnTimeout[2]		= "Reload";
	stateTimeoutValue[2]			= 0.7;
	stateFire[2]					= true;
	stateAllowImageChange[2]		= false;
	stateScript[2]					= "onFire";
	stateWaitForTimeout[2]			= true;

	stateName[3]					= "Reload";
	stateSequence[3]				= "Reload";
	stateTransitionOnTriggerUp[3]	= "Ready";
	stateTransitionOnTriggerDown[3]	= "Fire";
	stateSequence[3]				= "Ready";
};

function iShockWaveImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.mountImage(LeftHandediShockWaveImage, 1);
   %obj.playThread(1, armreadyboth);
}
function iShockWaveImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   %obj.unMountImage(1);
   %obj.playThread(1, root);
}

function iShockWaveImage::onFire(%this, %obj, %slot)
{
	if(%obj.lst[%this] > getSimTime())
	{
		return;
	}
	%obj.lst[%this] = getSimTime() + 700;
	if(%obj.getDatablock().isMage)
	{
		if(%obj.hasEnergy(%this.MPused))
		{
			parent::onFire(%this, %obj, %slot);
			%obj.setEnergyLevel(%obj.getEnergyLevel() - %this.MPused);
		}
		else if(isObject(%client = %obj.getControllingClient()))
		{
			%client.centerPrint("\c4Not enough Electricity!", 3);
		}
	}
	else
	{
		parent::onFire(%this, %obj, %slot);
	}
}

package iShockWave
{
	function armor::damage(%this, %obj, %sourceObject, %pos, %amt, %type)
	{
		if(%type == $DamageType::iShockWaveR || %type == $DamageType::iShockWaveD)
		{
			if(%obj.getWaterCoverage() > 0)
			{
				%amt*= 1.5;
			}
			if(%obj.getWaterCoverage() == 1)
			{
				%amt*= 1.5;
			}
		}
		parent::damage(%this, %obj, %sourceObject, %pos, %amt, %type);
	}
};
activatePackage(iShockWave);